package org.cocktail.fwkcktlwebapp.server.components;
// Generated by the WOLips TemplateEngine Plug-in at 5 mars 2005 22:40:32

import org.cocktail.fwkcktlwebapp.common.CktlLog;
import org.cocktail.fwkcktlwebapp.common.util.FileCtrl;
import org.cocktail.fwkcktlwebapp.common.util.StringCtrl;
import org.cocktail.fwkcktlwebapp.common.util.SystemCtrl;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WOResponse;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSMutableArray;

/**
 * Gere le depot des fichiers dans une application WebObjects. Ce composant
 * permet de deposer plusieurs fichiers.
 * 
 * <p>
 * 	<div class="importantNote">
 * 		<b>Attention</b>, pour fonctionner, ce composant doit &ecirc;tre inclus dans un <code>WOForm</code>,
 * 		et ce dernier doit avoir le binding <code>enctype</code> = <em>"multipart/form-data"</em> mais 
 * 		aussi <code>multipleSubmit</code> = <em>true</em>.
 *	</div>
 * </p>
 * 
 * <p>
 * 	<div align="center">
 * 		<img src="../../../../doc-files/CktlFileUpload-1.png" border="1"/><br/><br/>
 * 		<img src="../../../../doc-files/CktlFileUpload-2.png" border="1"/><br/><br/>
 * 		<img src="../../../../doc-files/CktlFileUpload-3.png" border="1"/>
 * 	</div>
 * </p>
 * 
 * <p>
 *  <table width="95%" border="0" cellspacing="2" cellpadding="3" align="center">
 *	 <tr align="center" class="paramBoxHeader">
 *	  <td>Connecteur</td>
 *	  <td>Definition</td>
 *	  <td>Valeur</td>
 *	  <td>Description</td>
 *	 </tr>
 *	 <tr align="center" valign="top" class="paramBoxContents">
 *	  <td><code>filePaths</code></td>
 *	  <td>obligatoire</td>
 *	  <td><code>String</code><br>[<i>null</i>]</td>
 *	  <td align="left">Tableau contenant la liste des chemins des fichiers attach&eacute;s</td>
 *	 </tr>
 *	 <tr align="center" valign="top" class="paramBoxContents">
 *	  <td><code>destDir</code></td>
 *	  <td>obligatoire</td>
 *	  <td><code>String</code><br>[<i>null</i>]</td>
 *	  <td align="left">Le r&eacute;pertoire de destination des fichiers envoy&eacute;. 
 *				Si non trouv&eacute;, alors c'est le r&eacute;pertoire temporaire du serveur qui est utilis&eacute;.</td>
 *	 </tr>
 *	 <tr align="center" valign="top" class="paramBoxContents">
 *	  <td><code>resetFilePaths</code></td>
 *	  <td>optionnel</td>
 *	  <td><code>boolean</code><br>[<i>false</i>]</td>
 *	  <td align="left">Quand cette valeur passe &agrave; <em>true</em>, alors la liste <code>filePaths</code> est r&eacute;initialis&eacute;e</td>
 *	 </tr>
 *	 <tr align="center" valign="top" class="paramBoxContents">
 *	  <td><code>readOnly</code></td>
 *	  <td>optionnel</td>
 *	  <td><code>boolean</code><br>[<i>false</i>]</td>
 *	  <td align="left">Indique si les fichiers attach&eacute; ne doivent pas &egrave;tre modifi&eacute;s</td>
 *	 </tr>
 *	 <tr align="center" valign="top" class="paramBoxContents">
 *	  <td><code>boxTitle</code></td>
 *	  <td>optionnel</td>
 *	  <td><code>String</code><br>[<i>null</i>]</td>
 *	  <td align="left">Titre du composant</td>
 *	 </tr>
 *	</table>
 * </p>
 * @author Arunas STOCKUS <arunas.stockus at univ-lr.fr>
 */
public class CktlFileUpload 
	extends CktlWebComponent {
	
	// noms des connecteurs
  private static String BND_BOX_TITLE = "boxTitle";
  private static String BND_FILE_PATHS = "filePaths";
  private static String BND_DEST_DIR = "destDir";
  private static String BND_READ_ONLY = "readOnly";
  private static String BND_RESET_FILE_PATHS = "resetFilePaths";

  //
  private boolean addingNewFile;
  private NSMutableArray allFilePaths;
  private String newFinalFilePath;
  private String destDir;

  public String aFilePath;
  public String newFilePath;

  public CktlFileUpload(WOContext context) {
    super(context);
    addingNewFile = false;
    allFilePaths = new NSMutableArray();
    newFinalFilePath = null;
  }

  public boolean synchronizesVariablesWithBindings() {
    return false;
  }
  
  public boolean isReadOnly() {
    if (hasBinding(BND_READ_ONLY))
      return ((Boolean)valueForBinding(BND_READ_ONLY)).booleanValue();
    else
      return false;
  }
  
  public void appendToResponse(WOResponse response, WOContext context) {
    // On efface toutes les selections, si le binding indique que le composant
    // doit etre reinitialise
    // Attention, on n'efface pas les fichiers !
    if (hasBinding(BND_RESET_FILE_PATHS)) {
      if (((Boolean)valueForBinding(BND_RESET_FILE_PATHS)).booleanValue()) {
        allFilePaths.removeAllObjects();
        setValueForBinding(Boolean.FALSE, BND_RESET_FILE_PATHS);
      }
    }
    super.appendToResponse(response, context);
    // la css associee au composant
  	addLocalCss(response, "css/CtklFileUpload.css", fwkCktlWebAppFrameworkName());
  }
  
  private void filePathsToBinding() {
    setValueForBinding(allFilePaths.immutableClone(), BND_FILE_PATHS);
  }
  
  public NSArray allFilePaths() {
    return allFilePaths;
  }
  
  public NSArray allBoundedFilePaths() {
  	if (hasBinding(BND_FILE_PATHS) && (valueForBinding(BND_FILE_PATHS) != null))
      return (NSArray)valueForBinding(BND_FILE_PATHS);
    else
      return new NSArray();
  }
  
  public String boxTitle() {
    if (hasBinding(BND_BOX_TITLE))
      return StringCtrl.normalize((String)valueForBinding(BND_BOX_TITLE));
    else
      return null;
  }
  
  private String destDir() {
    if (destDir == null) {
      destDir = StringCtrl.emptyString();
      // On prend d'abord la valeur du binding
      if (hasBinding(BND_DEST_DIR))
        destDir = StringCtrl.normalize((String)valueForBinding(BND_DEST_DIR));
      // S'il n'est pas donne alors on essaye le repertoire temporaire du systeme
      if (destDir.length() == 0)
        destDir = SystemCtrl.tempDir();
      // On ajoute un nom de repertoire unique, pour eviter des problemes avec
      // plusieurs utilisateurs ou plusieurs composants dans la meme appli
      if (!destDir.endsWith("/")) destDir += "/";
      destDir += this.hashCode()+"/";
    }
    CktlLog.trace("destDir : "+destDir);
    return destDir;
  }
  
  public String newFinalFilePath() {
    if (newFinalFilePath == null) {
      newFinalFilePath = destDir();
      if (!newFinalFilePath.endsWith("/")) newFinalFilePath += "/";
      newFinalFilePath += StringCtrl.toBasicString(FileCtrl.getFileName(newFilePath));
      CktlLog.trace("newFinalFilePath : "+newFinalFilePath);
      String parDir = FileCtrl.getParentDirectory(newFinalFilePath);
      if (!FileCtrl.existsFile(parDir)) {
        // On cree les sous-repertoires, s'il le faut
        // Le repertoire racine doit exister
      	CktlLog.trace("Creating directory : "+parDir);
        if (FileCtrl.makeDirs(parDir, destDir()))
        	CktlLog.rawTrace(" create OK");
        else
        	CktlLog.rawTrace(" create FAILED !");
      }
    }
    return newFinalFilePath;
  }
  
  public String newStreamFilePath() {
  	CktlLog.trace("newStreamFilePath : "+newFinalFilePath());
    return newFinalFilePath();
  }
   
  /**
   * Le nom d'un fichier dans la liste
   */
  public String aFileName() {
    if (StringCtrl.normalize(aFilePath).length() > 0) {
    	String fileName = FileCtrl.getFileName(aFilePath);
    	return fileName;
    } else {
      return null;
    }
  }
  
  /**
   * La taille du fichier en cours (pas encore utilise)
   */
  public String aFileSize() {
  	String size = "";
    long fileSize = FileCtrl.getFileSize(aFilePath);
    if (fileSize < (long) 1000) {
  		size = fileSize + " o";
  	} else if (fileSize < (long) 1000000) {
   		size = ((int)fileSize/1000) + " Ko";
  	} else if (fileSize < (long) 1000000000) {
   		size = ((int)fileSize/1000000) + " Mo";
  	} else {
   		size = ((int)fileSize/1000000000) + " Go";
  	}
  	return size;
  }
  
  public boolean hasTitle() {
    return (StringCtrl.normalize(boxTitle()).length() > 0);
  }
  
  public boolean isShowToolbar() {
    return (!isReadOnly() && !addingNewFile);
  }
  
  public boolean isShowUploadField() {
    return (!isReadOnly() && addingNewFile);
  }
  
  public boolean hasFiles() {
    if (isReadOnly())
      return (allBoundedFilePaths().count() > 0);
    else
      return (allFilePaths.count() > 0);
  }
  
  /**
   * Supprimer le fichier en cours
   */
  public WOComponent doFileRemove() {
  	FileCtrl.deleteFile(aFilePath);
  	if (!FileCtrl.existsFile(aFilePath)) {
  		allFilePaths.removeIdenticalObject(aFilePath);
  	}
  	filePathsToBinding();
  	return null;
  }
  
  /**
   * Supprimer tous les fichier en cours
   *//*
  public WOComponent doFileRemoveAll() {
  	LRLog.trace("allFilePaths: "+allFilePaths  + " (" + allFilePaths.count() +")");
  	for (int i = 0; i < allFilePaths.count(); i++) {
	  	LRLog.trace("i "+i);
  		String fp = (String) allFilePaths.objectAtIndex(i);
	  	FileCtrl.deleteFile(fp);
	  	LRLog.trace("removing "+fp);
	  	if (!FileCtrl.existsFile(fp)) {
	  		allFilePaths.removeIdenticalObject(fp);
	  	}
		}
  	filePathsToBinding();
  	return null;
  }*/
  public WOComponent doFileRemoveAll() {
  	boolean hasDeleteError = false;
  	while (allFilePaths.count() > 0 && !hasDeleteError) {
  		String fp = (String) allFilePaths.objectAtIndex(0);
	  	FileCtrl.deleteFile(fp);
	  	if (!FileCtrl.existsFile(fp)) {
	  		allFilePaths.removeIdenticalObject(fp);
	  	} else {
	  		hasDeleteError = true;
	  		CktlLog.trace("Error deleting : " + fp);
	  	}
  	}
  	filePathsToBinding();
  	return null;
  }
  
  
  public WOComponent doFileAdd() {
    addingNewFile = true;
    newFinalFilePath = null;
    return null;
  }
  
  public WOComponent doFileAddOK() {
  	CktlLog.trace("newFinalFilePath : "+newFinalFilePath);
    newFinalFilePath();
    // controle supplementaire : on s'assure que l'utilisateur
    // a bien saisi un nom de fichier (ne se termine pas par "/")
    if (StringCtrl.normalize(newFinalFilePath).length() > 0 &&
    		!StringCtrl.normalize(newFinalFilePath).endsWith("/")) {
      if (!allFilePaths.containsObject(newFinalFilePath)) {
      	CktlLog.trace("New Uploaded File : "+newFinalFilePath);
        allFilePaths.addObject(newFinalFilePath);
        filePathsToBinding();
      }
    }
    addingNewFile = false;
    return null;
  }
  
  public WOComponent doFileAddCancel() {
    addingNewFile = false;
    return null;
  }

}